Attribute VB_Name = "DECLARE"
'Option Explicit
Option Base 0

Global noreader%

Global cardcheck%

' Eror structure
'=======================
Type T0ErrorStruct
    sw12 As Integer
    Err As Integer
End Type

' ISO7816 T=0 read or write
'==========================
Type T0InsStruct
    Cla As Integer
    INS As Integer
    P1 As Integer
    P2 As Integer
    p3 As Integer
End Type


Global udfound As Boolean

Global Handle As Long
Global buffout As String * 2096
Global buffin As String * 2096
Global cmdln As Long
Global datln As Long
Global Maxln As Long
Global datlnout As Long


Global cardok As Integer
Global reclen%
    
Global Rawdata As String * 255

Global adpu As T0InsStruct
Global part3err As T0ErrorStruct

Global recsize As Integer
Global fileid As String * 2

Global CardRead%
Global PINCODE$

Function HexToBin(ByVal InString As String) As String
Dim NewString As String
Dim CharPosn As Integer
Dim StringLen As Integer
Dim TempString As String

  TempString = InString
  StringLen = Len(TempString)
  TempString = TempString + "0"
  NewString = ""
  CharPosn = 1
  While CharPosn <= StringLen
    NewString = NewString + Chr$(UnHex(Mid$(TempString, CharPosn, 2)))
    CharPosn = CharPosn + 2
  Wend
  HexToBin = NewString
End Function


Function UnHex(ByVal HexString As String) As Long
Dim Nib1 As Integer
Dim Nib2 As Integer

  Nib1 = GetNib(Left$(HexString, 1))
  Nib2 = GetNib(Mid$(HexString, 2, 1))
  UnHex = Nib1 * 16 + Nib2

End Function

Function UnHexString(ByVal HexString As String) As String
Dim Position As Integer
Dim NewString As String
Dim Char As Integer

  Position = 1
  NewString = ""
  While Position + 1 < Len(HexString)
    Char = UnHex(Mid$(HexString, Position, 2))
    If Char > -1 Then
      NewString = NewString + Chr$(Char)
    End If
    Position = Position + 2
  Wend
  UnHexString = NewString
End Function



Function GetNib(ByVal Nib As String) As Integer
Dim Inib As Integer
  
  If Nib = "" Then
    Inib = 0
  Else
    Inib = Asc(Left$(Nib, 1)) - 48
  End If
  If Inib > 10 Then Inib = Inib - 7
  If Inib > 15 Then Inib = Inib - 32
  GetNib = Inib

End Function
