VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form PCSCFrm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Please select PCSC Reader Unit"
   ClientHeight    =   6480
   ClientLeft      =   3390
   ClientTop       =   3015
   ClientWidth     =   7470
   Icon            =   "pcscfrm.frx":0000
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6480
   ScaleWidth      =   7470
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton Command1 
      Caption         =   "&Close"
      Height          =   375
      Left            =   6120
      TabIndex        =   9
      Top             =   5880
      Width           =   1215
   End
   Begin VB.CommandButton BtnGetAttrib 
      Caption         =   "Get&Attributes"
      Height          =   375
      Left            =   4560
      TabIndex        =   7
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton BtnGetVersion 
      Caption         =   "Get&Version"
      Height          =   375
      Left            =   3120
      TabIndex        =   6
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton BtnClearContents 
      Caption         =   "C&learContent"
      Height          =   375
      Left            =   6120
      TabIndex        =   5
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton CardConnect 
      Caption         =   "Card &Connect"
      Enabled         =   0   'False
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   720
      Width           =   1335
   End
   Begin VB.CommandButton CardDisconnect 
      Caption         =   "Card &Disconnect"
      Height          =   375
      Left            =   1680
      TabIndex        =   4
      Top             =   720
      Width           =   1335
   End
   Begin RichTextLib.RichTextBox Message 
      DataSource      =   "False"
      Height          =   3615
      Left            =   240
      TabIndex        =   3
      Top             =   1200
      Width           =   7095
      _ExtentX        =   12515
      _ExtentY        =   6376
      _Version        =   393217
      BorderStyle     =   0
      HideSelection   =   0   'False
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"pcscfrm.frx":000C
   End
   Begin VB.ComboBox ReaderListCombo 
      Height          =   315
      Left            =   1560
      TabIndex        =   2
      Text            =   "ReaderListCombo"
      Top             =   240
      Width           =   5895
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"pcscfrm.frx":008E
      Height          =   495
      Left            =   840
      TabIndex        =   8
      Top             =   5040
      Width           =   6015
   End
   Begin VB.Image CrnLogo 
      Height          =   555
      Left            =   2520
      Picture         =   "pcscfrm.frx":0119
      ToolTipText     =   "www.3gforensics.org"
      Top             =   5640
      Width           =   2610
   End
   Begin VB.Label ReaderListLabel 
      Caption         =   "Select a Reader :"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "PCSCFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************************
'
'    Sample application for accessing PC/SC Resource Manager
'
'**************************************************************************

Private Function StringToBytArray(command As String) As BytArray

Dim iLen As Integer
Dim szTemp As String
Dim btArrTemp As BytArray
Dim iLower As Integer, iUpper As Integer

szTemp = UCase(CommandCombo.Text)
iLen = Len(szTemp)
If iLen Mod 2 <> 0 Or iLen = 0 Then
    MsgBox "Please Check the command that you have entered.", vbCritical + vbOKOnly
    bConversion = False
    Exit Function
End If

Dim i As Integer
Dim count As Long

i = 1
count = 0
While i <= iLen
    iLower = -1
    iUpper = -1
    On Error Resume Next
    iUpper = CInt(Mid(szTemp, i, 1))
    If iUpper = -1 Then
        iUpper = Asc(Mid(szTemp, i, 1)) - 55
        If iUpper >= 16 Then
            MsgBox "Invalid Charcter entered", vbCritical + vbOKOnly
            bConversion = False
            Exit Function
        End If
    End If
    On Error Resume Next
    iLower = CInt(Mid(szTemp, i + 1, 1))
    If iLower = -1 Then
        iLower = Asc(Mid(szTemp, i + 1, 1)) - 55
        If iLower >= 16 Then
            MsgBox "Invalid Charcter entered", vbCritical + vbOKOnly
            bConversion = False
            Exit Function
        End If
    End If
    i = i + 2
    btArrTemp.byBytes(count) = iUpper * 16 + iLower
    count = count + 1
Wend

StringToBytArray = btArrTemp
bConversion = True
End Function

Private Sub BtnClearContents_Click()
    Message.Text = ""
'    CommandCombo.Clear
End Sub

Private Sub BtnGetAttrib_Click()

Dim bytRecvAttr As BytArray
Dim lRecLen As Long

'  Getting vendor name
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_VENDOR_NAME, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Vendor Name"
Else
    szMessage = "VendorName    : " + BytArrayToString(bytRecvAttr, lRecLen) + vbNewLine
    Message.Text = szMessage
End If

' Getting vendor IFD type
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_VENDOR_IFD_TYPE, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get IFD Type"
Else
    szMessage = "IFD Type          : " + BytArrayToString(bytRecvAttr, lRecLen) + vbNewLine
    Message.Text = Message.Text + szMessage
End If

'   Getting IFD version
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_VENDOR_IFD_VERSION, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get IFD Version"
Else
    Dim szTemp As String
    Dim i As Integer
    i = lRecLen - 1
    szTemp = ""
    While i > 1
        szTemp = szTemp + Trim(Str(Hex(bytRecvAttr.byBytes(i)))) + "."
        i = i - 1
    Wend
    Dim lTemp As Long
    lTemp = bytRecvAttr.byBytes(1) * (2 ^ 8) + bytRecvAttr.byBytes(0)
    szTemp = szTemp + Trim(Str(Hex(lTemp)))
    szMessage = "IFD Version      : " + szTemp + vbNewLine
    Message.Text = Message.Text + szMessage
End If
 
' Getting channel ID
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_CHANNEL_ID, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get channel ID"
Else
    i = 0
    szTemp = ""
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    lTemp = lTemp And &HFFFF0000
    
    szTemp = ""
    Select Case lTemp
        Case &H10000
            szTemp = "Serial," + Trim(Str(Hex(lTemp)))
        Case &H20000
            szTemp = "Parallel," + Trim(Str(Hex(lTemp)))
        Case &H40000
            szTemp = "PS/2," + Trim(Str(Hex(lTemp)))
        Case &H80000
            szTemp = "SCSI," + Trim(Str(Hex(lTemp)))
        Case &H100000
            szTemp = "IDE," + Trim(Str(Hex(lTemp)))
        Case &H200000
            szTemp = "USB," + Trim(Str(Hex(lTemp)))
        Case &H400000
            szTemp = "PCMCIA," + Trim(Str(Hex(lTemp)))
        Case Else
            szTemp = "Unknown Channel," + Trim(Str(Hex(lTemp)))
    End Select
    szMessage = "Channel  ID      : " + szTemp + vbNewLine
    Message.Text = Message.Text + szMessage
End If

' Getting Default clock
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_DEFAULT_CLK, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Default Clock"
Else
    i = 0
    szTemp = ""
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    
    szMessage = "Default clock    : " + Str(lTemp) + vbNewLine
    Message.Text = Message.Text + szMessage
End If

' Getting default data rate

lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_DEFAULT_DATA_RATE, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Default Data rate"
Else
    i = 0
    szTemp = ""
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    
    szMessage = "Def. data rate   : " + Str(lTemp) + vbNewLine
    Message.Text = Message.Text + szMessage
End If

' Getting max clock rate
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_MAX_CLK, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Max Clock"
Else
    i = 0
    szTemp = ""
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    
    szMessage = "Max Clock        : " + Str(lTemp) + vbNewLine
    Message.Text = Message.Text + szMessage
End If

' Getting max data rate
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_MAX_DATA_RATE, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Max Data rate"
Else
    i = 0
    szTemp = ""
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    
    szMessage = "Max Data rate  : " + Str(lTemp) + vbNewLine
    Message.Text = Message.Text + szMessage
End If

' Getting IFSD
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_MAX_IFSD, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Max IFSD"
Else
    i = 0
    szTemp = ""
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    
    szMessage = "Max IFSD         : " + Str(lTemp) + vbNewLine
    Message.Text = Message.Text + szMessage
End If

' Getting card status
lRecLen = 255
lResult = SCardGetAttrib(hCard, SCARD_ATTR_ICC_PRESENCE, bytRecvAttr, lRecLen)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Failed to get Card Status"
Else
    i = 0
    szTemp = ""
    Dim bCardStatus As Boolean
    bCardStatus = False
    lTemp = 0
    While i < lRecLen
        lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
        i = i + 1
    Wend
    If (lTemp And &HFF) = 0 Then
        szTemp = "Removed"
        bCardStatus = False
    Else
        szTemp = "Inserted"
        bCardStatus = True
    End If
    szMessage = "Card status       : " + szTemp + vbNewLine
    Message.Text = Message.Text + szMessage
End If

If bCardStatus Then
    ' Getting ATR
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_ATR_STRING, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get ATR"
    Else
        szMessage = "ATR                 : " + DecimalToString(bytRecvAttr, lRecLen, True) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If


    ' Getting protocol
    szMessage = "Protocol           : " + szProtocol + vbNewLine
    Message.Text = Message.Text + szMessage
    
    ' Getting current block
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_CLK, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Current Clock rate"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Current Clock   : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting current clock rate conversion factor (F)
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_F, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Current Clock rate conversion factor"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Current F          : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting current buad rate conversion factor (D)
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_D, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Current baud rate conversion factor"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Current D          : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    ' Getting current Extra gaurd time (N)
    lRecLen = 255
    lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_N, bytRecvAttr, lRecLen)
    If lResult <> SCARD_S_SUCCESS Then
        MsgBox "Failed to get Current extragaurd time"
    Else
        i = 0
        szTemp = ""
        lTemp = 0
        While i < lRecLen
            lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
            i = i + 1
        Wend
        
        szMessage = "Current N          : " + Str(lTemp) + vbNewLine
        Message.Text = Message.Text + szMessage
    End If
    
    If lProtocol = SCARD_PROTOCOL_T1 Then
        '  Getting current character waiting time (CWT)
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_CWT, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current CWT"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current CWT    : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
        
        '  Getting current Block waiting time (BWT)
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_BWT, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current BWT"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current BWT    : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
    
        '  Getting current character waiting time (IFSC)
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_IFSC, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current IFSC"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current IFSC     : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
    Else
        '  Getting current W
        lRecLen = 255
        lResult = SCardGetAttrib(hCard, SCARD_ATTR_CURRENT_IFSC, bytRecvAttr, lRecLen)
        If lResult <> SCARD_S_SUCCESS Then
            MsgBox "Failed to get Current W"
        Else
            i = 0
            szTemp = ""
            lTemp = 0
            While i < lRecLen
                lTemp = lTemp + (bytRecvAttr.byBytes(i) * (2 ^ (i * 8)))
                i = i + 1
            Wend
            
            szMessage = "Current W         : " + Str(lTemp) + vbNewLine
            Message.Text = Message.Text + szMessage
        End If
    
    End If            '  lProtocol = SCARD_PROTOCOL_T1
End If

End Sub

Private Sub BtnGetVersion_Click()

Dim vcVersion As VERSION_CONTROL
'Dim vcVersion As Variant
Dim lReturnedLength As Long

lResult = SCardControl(hCard, IOCTL_GET_VERSIONS, 0, 0, vcVersion, 20, _
                       lReturnedLength)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "SCardControl failed with  : " + Hex(lResult) + " Internal Error"
    Exit Sub
End If

Dim szTemp As String
szTemp = Str(Hex(vcVersion.SmclibVersion))
szMessage = "SMCLIB: V"
szMessage = szMessage + Mid(szTemp, 2, 1) + "." + Mid(szTemp, 3, 2)
szMessage = szMessage + vbNewLine + "Driver: "
szMessage = szMessage + "V" + Trim(Str(vcVersion.DriverMajor)) + "."

szTemp = ""
If vcVersion.DriverMinor < 10 Then
    szTemp = "0"
End If
szTemp = szTemp + Trim(Str(vcVersion.DriverMinor))
szMessage = szMessage + szTemp + vbNewLine + "Firmware: V" + _
            Trim(Str(Hex(vcVersion.FirmwareMajor))) + "."

szTemp = ""
If vcVersion.FirmwareMinor < 10 Then
    szTemp = "0"
End If
szTemp = szTemp + Trim(Str(Hex(vcVersion.FirmwareMinor)))
szMessage = szMessage + szTemp
Message.Text = szMessage

End Sub




Private Sub CardConnect_Click()

Call connectcard
'
'
'If lAtrLen < 255 Then
'    If lAtrLen > 0 Then
'
'        Unload Me
'
'    End If
'
'Else
'    MsgBox "Please recheck reader and sim card are conected, Then try again."
'End If

'Unload Me


End Sub

Private Sub CardDisconnect_Click()


Call DisconnectCard

Exit Sub

End Sub




Private Sub Command1_Click()
    Unload Me
End Sub

Private Sub Form_Load()

Dim mszGroups As String
Dim szReaderLists As String * 256





bConversion = False
lResult = SCardEstablishContext(SCARD_SCOPE_USER, 0, 0, hContext)
If lResult <> SCARD_S_SUCCESS Then
    MsgBox "Cannot establish connection"
    MsgBox "ReturnCode(ESTACON):  " + Hex(lResult)
End If

nReaderCount = 255
lResult = SCardListReaders(hContext, mszGroups, szReaderLists, nReaderCount)
Call LoadListToControl(ReaderListCombo, szReaderLists)
Dim iTemp As Integer
iTemp = ReaderListCombo.ListCount
If iTemp <> 0 Then
    ReaderListCombo.ListIndex = 0
    CardConnect.Enabled = True
    szReaderName = ReaderListCombo.Text
End If
End Sub

Public Sub LoadListToControl(ByVal Ctrl As ComboBox, ByVal ReaderList As String)
Dim sTemp As String
Dim Index As Integer

Index = 1
sTemp = ""
Ctrl.Clear
While (Mid(ReaderList, Index, 1) <> vbNullChar)
    While (Mid(ReaderList, Index, 1) <> vbNullChar)
       sTemp = sTemp + Mid(ReaderList, Index, 1)
       Index = Index + 1
    Wend
    Index = Index + 1
    Ctrl.AddItem sTemp
    sTemp = ""
Wend

End Sub

Private Sub Form_Terminate()
If hCard <> 0 Then
    lResult = SCardDisconnect(hCard, SCARD_RESET_CARD)
    hCard = 0
End If
If hContext <> 0 Then
    lResult = SCardReleaseContext(hContext)
    hContext = 0
End If
End Sub


